﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using ControlCAN;

namespace LysUsbcanDemo
{
    public partial class Form1 : Form
    {
        /// <summary>
        /////////////////////////////全局/////////////////////////////////////////////
        //仲裁域查找表
        private UInt32[] kAbitTiming = {
            0x01400106,//1Mbps
            0x0100020A,//800kbps
            0x02C00106,//500kbps
            0x05C00106,//250kbps
            0x0BC00106,//125kbps
            0x0EC00106,//100kbps
            0x1DC00106 //50kbps
        };
        //数据域查找表
        private UInt32[] kDbitTiming = {
            0x00800001,//5Mbps
            0x00800002,//4Mbps
            0x00800106,//2Mbps
            0x01400106,//1Mbps
            0x0100020A,//800kbps
            0x02C00106,//500kbps
            0x05C00106,//250kbps
            0x0BC00106,//125kbps
            0x0EC00106,//100kbps
            0x1DC00106 //50kbps
        };

        private byte[] kTiming0 = {
            0x00,//1000kbps
            0x00,//800kbps
            0x00,//500kbps
            0x01,//250kbps
            0x03,//125kbps
            0x04,//100kbps
            0x09,//50kbps
            0x18,//20kbps
            0x31,//10kbps
            0xBF //5kbps
        };
        private byte[] kTiming1 = {
            0x14,//1000kbps
            0x16,//800kbps
            0x1C,//500kbps
            0x1C,//250kbps
            0x1C,//125kbps
            0x1C,//100kbps
            0x1C,//50kbps
            0x1C,//20kbps
            0x1C,//10kbps
            0xFF //5kbps
        };
        ///////////////////////////////变量区/////////////////////////////////////////
        //设备连接状态
        bool m_devConnect = false;
        //设备类型
        UInt32 m_devType;
        //设备索引
        UInt32 m_devIndex;
        //通道索引
        UInt32 m_devChIndex;
        //工作模式
        UInt32 m_devWorkMode;
        //过滤器模式
        UInt32 m_devFliterMode;
        //是否是FD设备
        bool isFd;
        //CAN配置信息
        LCAN_INIT_CONFIG canInitCfgInfo;
        //FD配置信息
        LCAN_INITFD_CONFIG canInitFDCfgInfo;
        //////////////////////////////////////////////////////////////////////////////


        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //
            windowInit();
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:窗口初始化
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void windowInit()
        {
            //设备
            m_devType = LCAN_Device.LCAN_USBCAN1;
            m_devIndex = 0;
            m_devChIndex = 0;
            m_devConnect = false;
            m_devWorkMode = 0;
            isFd = false;

            //UI
            comboBox_devType.SelectedIndex = 0;
            comboBox_devIndex.SelectedIndex = 0;
            comboBox_chIndex.SelectedIndex = 0;
            //default 500K
            comboBox_baud.SelectedIndex = 2;
            comboBox_aBaud.SelectedIndex = 0;
            comboBox_dBaud.SelectedIndex = 0;
            comboBox_iso.SelectedIndex = 0;
            //单滤波模式
            comboBox_fliterMode.SelectedIndex = 1;
            comboBox_workMode.SelectedIndex = 0;
            comboBox_sendMode.SelectedIndex = 0;
            comboBox_frameType.SelectedIndex = 0;
            comboBox_frameFormat.SelectedIndex = 0;
            comboBox_framePro.SelectedIndex = 0;

            textBox_accCode.Text = "00000000";
            textBox_maskCode.Text = "FFFFFFFF";
            //帧ID
            textBox_frameId.Text = "00000000";
            //帧数据
            textBox_frameData.Text = "00 01 02 03 04 05 06 07";
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:窗口更新
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void windowUpdate()
        {
            if(true == m_devConnect)
            {
                
                button_devOpen.Enabled = false;
                button_devOpen.Enabled = false;
                button_devClose.Enabled = true;
                button_devSend.Enabled =true;
            }
            else
            {
                button_devOpen.Enabled = true;
                button_devClose.Enabled = false;
                button_devSend.Enabled =false;
            }

            //设备已连接
            if(m_devConnect)
            {
                //CAN相关配置,不能修改
                comboBox_baud.Enabled =false;
                comboBox_fliterMode.Enabled =false;
                textBox_accCode.Enabled = false;
                textBox_maskCode.Enabled = false;

                //CANFD相关配置,不能修改
                comboBox_aBaud.Enabled =false;
                comboBox_dBaud.Enabled =false;
                comboBox_iso.Enabled =false;
                if(true == isFd)
                {
                    //FD无远程帧
                    if(0 != comboBox_framePro.SelectedIndex)
                    {
                        comboBox_frameFormat.Enabled =false;
                        comboBox_frameFormat.SelectedIndex = 0;
                    }
                    else
                    {
                        comboBox_frameFormat.Enabled =true;
                    }
                }
                else
                {
                    comboBox_frameFormat.Enabled =true;
                }

                //工作模式 设备类型
                comboBox_workMode.Enabled =false;
                comboBox_devType.Enabled =false;
                comboBox_devIndex.Enabled =false;
                comboBox_chIndex.Enabled =false;
            }
            else
            {
                if(isFd)
                {
                    //CAN2.0相关
                    comboBox_baud.Enabled =false;
                    comboBox_fliterMode.Enabled =false;
                    textBox_accCode.Enabled = false;
                    textBox_maskCode.Enabled = false;

                    //FD相关组件
                    comboBox_aBaud.Enabled =true;
                    comboBox_dBaud.Enabled =true;
                    comboBox_iso.Enabled =true;
                    comboBox_framePro.Enabled =true;
                }
                else
                {
                    //CAN2.0相关
                    comboBox_baud.Enabled =true;
                    comboBox_fliterMode.Enabled =true;
                    textBox_accCode.Enabled = true;
                    textBox_maskCode.Enabled = true;

                    //FD相关组件
                    comboBox_aBaud.Enabled =false;
                    comboBox_dBaud.Enabled =false;
                    comboBox_iso.Enabled =false;
                    comboBox_framePro.Enabled =false;
                }

                //工作模式 设备类型
                comboBox_workMode.Enabled =true;
                comboBox_devType.Enabled =true;
                comboBox_devIndex.Enabled =true;
                comboBox_chIndex.Enabled =true;
            }
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:窗口新增显示数据
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void windowAddData( string data )
        {
            listBox_data.Items.Add(data);
            listBox_data.SelectedIndex = listBox_data.Items.Count - 1;
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明: 显示CAN数据帧
        */
        private void windowAddData( LCAN_CAN_OBJ[] dataObj, int len)
        {
            for(int i=0;i<len;i++)
            {
                String str = "";
                str = "接收到CAN ID:" + System.Convert.ToString((Int32)dataObj[i].id, 16);
                str += " 长度:" + System.Convert.ToString(dataObj[i].dataLen, 10);
                //帧类型
                if (0x01 == dataObj[i].externFlag)
                {
                    str += " 扩展帧";
                }
                else
                {
                    str += " 标准帧";
                }
                if (0x01 == dataObj[i].remoteFlag)
                {
                    str += " 远程帧";
                }
                else
                {
                    str += " 数据帧" + " 数据:";
                    //数据
                    for (int j = 0; j < dataObj[i].dataLen; j++)
                    {
                        str += System.Convert.ToString(dataObj[i].data[j], 16) + " ";
                    }
                }
                //添加显示
                windowAddData(str);
            }/*for(int i=0;i<len;i++)*/
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明: 显示CANFD数据帧
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void windowAddData(LCAN_CANFD_OBJ[] dataObj, int len)
        {
            for (int i = 0; i < len; i++)
            {
                String str = "";
                str = "接收到CANFD ID:" + System.Convert.ToString((Int32)dataObj[i].id, 16);
                str += "长度:" + System.Convert.ToString(dataObj[i].dataLen, 10);
                //帧类型
                if (0x01 == dataObj[i].externFlag)
                {
                    str += " 扩展帧";
                }
                else
                {
                    str += " 标准帧";
                }
                if (0x01 == dataObj[i].remoteFlag)
                {
                    str += " 远程帧";
                }
                else
                {
                    str += " 数据帧" + " 数据:";
                    //数据
                    for (int j = 0; j < dataObj[i].dataLen; j++)
                    {
                        str += System.Convert.ToString(dataObj[i].data[j], 16) + " ";
                    }
                }
                //添加显示
                windowAddData(str);
            }/*for(int i=0;i<len;i++)*/
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:window组件刷新
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        public void windowDevInitCfgGetHandle()
        {
            //获取变量值
            m_devIndex = Convert.ToUInt32(comboBox_devIndex.SelectedIndex);
            m_devChIndex = Convert.ToUInt32(comboBox_chIndex.SelectedIndex);
            m_devFliterMode = Convert.ToUInt32(comboBox_fliterMode.SelectedIndex);
            m_devWorkMode = Convert.ToUInt32(comboBox_workMode.SelectedIndex);

            if(isFd)
            {
                //FD
                if(0 != comboBox_iso.SelectedIndex)
                {
                    canInitFDCfgInfo.isoEn = 1;
                }
                else
                {
                    canInitFDCfgInfo.isoEn = 0;
                }

                //工作于FD模式
                canInitFDCfgInfo.abit_timing = kAbitTiming[comboBox_aBaud.SelectedIndex];
                canInitFDCfgInfo.dbit_timing = kDbitTiming[comboBox_dBaud.SelectedIndex];
                canInitFDCfgInfo.fdEn = 1;

            }
            else
            {
                //CAN
                canInitCfgInfo.accCode = System.Convert.ToUInt32("0x" + textBox_accCode.Text, 16);
                canInitCfgInfo.accMask = System.Convert.ToUInt32("0x" + textBox_maskCode.Text, 16); ;
                canInitCfgInfo.timing0 = kTiming0[comboBox_baud.SelectedIndex]; ;
                canInitCfgInfo.timing1 = kTiming1[comboBox_baud.SelectedIndex];;
                canInitCfgInfo.filter = (byte)comboBox_fliterMode.SelectedIndex;
                canInitCfgInfo.mode = (byte)m_devWorkMode;
            }
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:设备连接处理
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void devConnectHandle()
        {
            if (false == m_devConnect)
            {
                //设备还未连接,开始连接
                windowDevInitCfgGetHandle();
                //open
                if (LCAN_Device.LCAN_OpenDevice(m_devType, m_devIndex) != LCAN_STATUS.STATUS_OK)
                {
                    //fail
                    windowAddData("打开设备失败");
                    return;
                }
                if(isFd)
                {
                    //FD设备
                    if (0 >= LCAN_Device.LCAN_InitCANFD(m_devType, m_devIndex, m_devChIndex, ref canInitFDCfgInfo))
                    {
                        //初始化失败
                        windowAddData("初始化设备失败");
                        LCAN_Device.LCAN_CloseDevice(m_devType, m_devIndex);
                        return;
                    }
                }
                else
                {
                    //CAN2.0设备
                    if (0 >= LCAN_Device.LCAN_InitCAN(m_devType, m_devIndex, m_devChIndex, ref canInitCfgInfo))
                    {
                        //初始化失败
                        windowAddData("初始化设备失败");
                        LCAN_Device.LCAN_CloseDevice(m_devType, m_devIndex);
                        return;
                    }
                }
                //
                m_devConnect = true;
                //启动线程
                timer_rec.Enabled = true;
            }
            else
            {
                m_devConnect = false;
                timer_rec.Enabled = false;
                //停止线程
                //threadReqExit = true;

                LCAN_Device.LCAN_CloseDevice(m_devType, m_devIndex);
            }

            //fresh
            windowUpdate();
        }

        private int str2Hex(byte[] dst, int maxLen, ref String strSrc)
        {
            String strNew = "";
            int i,hexByte,cnt=0;

            if(0 == strSrc.Length)
            {
                //err
                return 0;
            }

            if(0 >= maxLen)
            {
                //err
                return 0;
            }
            char [] srcArray = strSrc.ToCharArray();
            for(i=0;i<srcArray.Length;i++)
            {
                if(' '!= srcArray[i])
                {
                    strNew += srcArray[i];
                }
            }

            hexByte = strNew.Length/2;
            
            for (i = 0; i < hexByte; i++)
            {
                dst[i] = System.Convert.ToByte("0x" + strNew.Substring(i * 2, 2), 16);
                cnt++;
                if(maxLen <= cnt)
                {
                    //over
                    break;
                }
            }

            return cnt;
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:设备CAN发送处理
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void devCanSendHandle()
        {
            String strId,strData;
            LCAN_CAN_OBJ[] frameinfo = new LCAN_CAN_OBJ[32];

            strId = textBox_frameId.Text;
            if(0 == strId.Length)
            {
                windowAddData("ID不能为空");
                return;
            }

            strData = textBox_frameData.Text;
            if (0 == strData.Length)
            {
                windowAddData("发送数据不能为空");
                return;
            }

            //DATA
            frameinfo[0].data = new byte[LCAN_DATA_DLC.CAN_DATA_DLC_MAX];
            frameinfo[0].dataLen = (byte)str2Hex(frameinfo[0].data, (int)LCAN_DATA_DLC.CAN_DATA_DLC_MAX, ref strData);
            frameinfo[0].remoteFlag = (byte)comboBox_frameFormat.SelectedIndex;
            frameinfo[0].externFlag = (byte)comboBox_frameType.SelectedIndex;
            frameinfo[0].id = System.Convert.ToUInt32("0x" + strId, 16);
            if (1 == frameinfo[0].externFlag)
            {
                frameinfo[0].id &= 0x1FFFFFFF;
            }
            else
            {
                frameinfo[0].id &= 0x000007FF;
            }

            frameinfo[0].sendType = (byte)comboBox_sendMode.SelectedIndex;
            //远程帧
            if (1 == frameinfo[0].remoteFlag)
            {
                //数据必须为空
                frameinfo[0].dataLen = 0;
            }

            UInt32 ret = LCAN_Device.LCAN_Transmit(m_devType, m_devIndex, m_devChIndex, frameinfo, 1);
            if (0 >= ret)
            {
                //发送失败
                windowAddData("发送失败");
            }
            else
            {
                //发送成功
                windowAddData("发送成功");
            }
        }

        /**
        * @输入参数: 无
        * @输出参数: 无
        * @返 回 值: 无
        * @说    明:设备CANFD发送处理
        * 版权:长沙六叶树教育科技有限公司
        * 官网:www.liuyeshu.cn
        * 更多资料教程下载见官网
        */
        private void devCanFDSendHandle()
        {
            String strId,strData;
            LCAN_CANFD_OBJ[] frameinfo = new LCAN_CANFD_OBJ[32];

            strId = textBox_frameId.Text;
            if(0 == strId.Length)
            {
                windowAddData("ID不能为空");
                return;
            }

            strData = textBox_frameData.Text;
            if (0 == strData.Length)
            {
                windowAddData("发送数据不能为空");
                return;
            }

            //DATA
            frameinfo[0].data = new byte[LCAN_DATA_DLC.CANFD_DATA_DLC_MAX];
            frameinfo[0].dataLen = (byte)str2Hex(frameinfo[0].data, (int)LCAN_DATA_DLC.CANFD_DATA_DLC_MAX, ref strData);
            frameinfo[0].remoteFlag = (byte)comboBox_frameFormat.SelectedIndex;
            frameinfo[0].externFlag = (byte)comboBox_frameType.SelectedIndex;
            frameinfo[0].id = System.Convert.ToUInt32("0x" + strId, 16);
            if(1 == frameinfo[0].externFlag)
            {
                frameinfo[0].id &= 0x1FFFFFFF;
            }
            else
            {
                frameinfo[0].id &= 0x000007FF;
            }

            frameinfo[0].sendType = (byte)comboBox_sendMode.SelectedIndex;

            //FD设备的BRS
            frameinfo[0].flag = 0;
            switch(comboBox_framePro.SelectedIndex)
            {
            case 2:
                //fd brs
                frameinfo[0].flag |= LCAN_FD_FLAG.LCAN_CANFD_BRS;
                break;
            default:
                break;
            }

            UInt32 ret = LCAN_Device.LCAN_TransmitFD(m_devType, m_devIndex, m_devChIndex, frameinfo, 1);
            if (0 >= ret)
            {
                //发送失败
                windowAddData("发送失败");
            }
            else
            {
                //发送成功
                windowAddData("发送成功");
            }
        }

        //数据接收处理
        private void devRecHandle()
        {
            UInt32 res;

            ///////////////////////////////////CAN数据接收///////////////////////////////////////////////
            res = LCAN_Device.LCAN_GetReceiveNum(m_devType, m_devIndex, m_devChIndex, 0);
            if (0 < res)
            {
                UInt32 maxNum = 32;
                IntPtr pt = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(LCAN_CAN_OBJ)) * (Int32)maxNum);
                UInt32 len = LCAN_Device.LCAN_Receive(m_devType, m_devIndex, m_devChIndex, pt, maxNum, 50);
                LCAN_CAN_OBJ[] canObj = new LCAN_CAN_OBJ[maxNum];
                for (UInt32 i = 0; i < len; i++)
                {
                    canObj[i] = (LCAN_CAN_OBJ)Marshal.PtrToStructure((IntPtr)((long)pt + i * Marshal.SizeOf(typeof(LCAN_CAN_OBJ))), typeof(LCAN_CAN_OBJ));
                    
                }
                //show
                windowAddData(canObj, (int)len);
                //free res
                Marshal.FreeHGlobal(pt);
            }

            ///////////////////////////////////FD数据接收///////////////////////////////////////////////
            res = LCAN_Device.LCAN_GetReceiveNum(m_devType, m_devIndex, m_devChIndex, 1);
            if (0 < res)
            {
                UInt32 maxNum = 32;
                IntPtr pt = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(LCAN_CANFD_OBJ)) * (Int32)maxNum);
                UInt32 len = LCAN_Device.LCAN_ReceiveFD(m_devType, m_devIndex, m_devChIndex, pt, maxNum, 50);
                LCAN_CANFD_OBJ[] fdObj = new LCAN_CANFD_OBJ[maxNum];
                for (UInt32 i = 0; i < len; i++)
                {
                    fdObj[i] = (LCAN_CANFD_OBJ)Marshal.PtrToStructure((IntPtr)((long)pt + i * Marshal.SizeOf(typeof(LCAN_CANFD_OBJ))), typeof(LCAN_CANFD_OBJ));
                }
                //show
                windowAddData(fdObj, (int)len);
                //free res
                Marshal.FreeHGlobal(pt);
            }

        }



        private void button2_Click(object sender, EventArgs e)
        {
            devConnectHandle();
        }

        //设备类型选择处理
        private void comboBox_devType_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBox_devType.SelectedIndex)
            {
                case 0:
                    //USBCAN1
                    isFd = false;
                    m_devType = LCAN_Device.LCAN_USBCAN1;
                    break;
                case 1:
                    //USBCAN2
                    isFd = false;
                    m_devType = LCAN_Device.LCAN_USBCAN2;
                    break;
                case 2:
                    //USBCANFDMini
                    isFd = true;
                    m_devType = LCAN_Device.LCAN_USBCANFDMini;
                    break;
                case 3:
                    //USBCANFD1
                    isFd = true;
                    m_devType = LCAN_Device.LCAN_USBCANFD1;
                    break;
                case 4:
                    //USBCANFD2
                    isFd = true;
                    m_devType = LCAN_Device.LCAN_USBCANFD2;
                    break;
                default:
                    isFd = false;
                    break;
            }

            //refresh
            windowUpdate();
        }

        private void comboBox_workMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            m_devWorkMode = (UInt32)comboBox_workMode.SelectedIndex;
        }

        private void button_devSend_Click(object sender, EventArgs e)
        {
            if (false == m_devConnect)
            {
                //设备还未连接
                windowAddData("先打开设备!!!");
                return;
            }

            if ((true == isFd) && (0 != comboBox_framePro.SelectedIndex))
            {
                //FD模式
                devCanFDSendHandle();
            }
            else
            {
                //CAN2.0模式
                devCanSendHandle();
            }
        }

        private void button_devOpen_Click(object sender, EventArgs e)
        {
            devConnectHandle();
        }

        private void timer_rec_Tick(object sender, EventArgs e)
        {
            devRecHandle();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            listBox_data.Items.Clear();
        }
    }
}
